import UETest
import unreal

def CreateBasicActor( name ):
	# First we load static mesh(sphere) from the engine content directory
	meshAsset = unreal.load_asset( '/Engine/BasicShapes/' + name + '.' + name )
	#unreal.log(meshAsset)
    
	oxSubsystem = unreal.get_editor_subsystem( unreal.OrnatrixEditorSubsystem )
	return oxSubsystem.add_mesh_actor( meshAsset )

def CheckPointsNearEqual( self, point1, point2, epsilon = 0.01, extraMessage = '' ):
	error = point1.distance( point2 )
	self.assertGreaterEqual( epsilon, error, msg = '[' + str( point1 ) + '] is not near equal [' + str( point2 ) + '], error: ' + str( error ) + extraMessage )

def CheckPointsNotNearEqual( self, point1, point2, epsilon = 0.01, extraMessage = '' ):
	error = point1.distance( point2 )
	self.assertLessEqual( epsilon, error, msg = '[' + str( point1 ) + '] is near equal [' + str( point2 ) + '], error: ' + str( error ) + extraMessage )

def CheckPointsAllNearEqual( self, points1, points2, epsilon = 0.01, points1Start = 0, points2Start = 0, pointsCount = -1, extraMessage = '' ):
	if pointsCount == -1:
		pointsCount = len( points1 ) - points1Start
		self.assertEqual( pointsCount, len( points2 ) - points2Start )

	for i in range( 0, pointsCount ):
		CheckPointsNearEqual( self, points1[i + points1Start], points2[i + points2Start], epsilon = epsilon, extraMessage = extraMessage )

def CheckPointsNotAllNearEqual( self, points1, points2, epsilon = 0.01, points1Start = 0, points2Start = 0, pointsCount = -1, extraMessage = '' ):
	if pointsCount == -1:
		pointsCount = len( points1 ) - points1Start
		self.assertEqual( pointsCount, len( points2 ) - points2Start )

	areAllEqual = True
	for i in range( 0, pointsCount ):
		if not CheckPointsNearEqual( self, points1[i + points1Start], points2[i + points2Start], epsilon = epsilon, extraMessage = extraMessage ):
			areAllEqual = False
			break

	self.assertFalse( areAllEqual )